package java.rmi.registry;

import java.rmi.server.RMIServerSocketFactory;
import sun.rmi.server.Util;
import sun.rmi.server.UnicastRef2;
import sun.rmi.server.UnicastRef;
import sun.rmi.registry.RegistryImpl;
import sun.rmi.transport.LiveRef;
import sun.rmi.transport.tcp.TCPEndpoint;
import java.rmi.server.ObjID;
import java.net.InetAddress;
import java.rmi.server.RMIClientSocketFactory;
import java.rmi.RemoteException;

public final class LocateRegistry
{
    private LocateRegistry() {
    }
    
    public static Registry getRegistry() throws RemoteException {
        return getRegistry(null, 1099);
    }
    
    public static Registry getRegistry(int n) throws RemoteException {
        return getRegistry(null, n);
    }
    
    public static Registry getRegistry(String s) throws RemoteException {
        return getRegistry(s, 1099);
    }
    
    public static Registry getRegistry(String s, int n) throws RemoteException {
        return getRegistry(s, n, null);
    }
    
    public static Registry getRegistry(String hostAddress, int port, RMIClientSocketFactory csf) throws RemoteException {
        if (port <= 0) {
            port = 1099;
        }
        if (hostAddress == null || hostAddress.length() == 0) {
            try {
                hostAddress = InetAddress.getLocalHost().getHostAddress();
            }
            catch (Exception ex) {
                hostAddress = "";
            }
        }
        LiveRef o = new LiveRef(new ObjID(0), new TCPEndpoint(hostAddress, port, csf, null), false);
        return (Registry)Util.createProxy(RegistryImpl.class, (csf == null) ? new UnicastRef(o) : new UnicastRef2(o), false);
    }
    
    public static Registry createRegistry(int port) throws RemoteException {
        return new RegistryImpl(port);
    }
    
    public static Registry createRegistry(int port, RMIClientSocketFactory csf, RMIServerSocketFactory ssf) throws RemoteException {
        return new RegistryImpl(port, csf, ssf);
    }
}
